/*
	Copyright (C) 2012-2020 Center for Digital Humanities, Trier

	This file is part of the Online Transcription Editor (OTE).

    OTE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 2.1 of the License, or
    (at your option) any later version.

    OTE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OTE.  If not, see <http://www.gnu.org/licenses/>.

    Diese Datei ist Teil des Online-Transkriptions-Editor (OTE).

    OTE ist Freie Software: Sie können es unter den Bedingungen
    der GNU Lesser General Public License, wie von der Free Software Foundation,
    Version 2.1 der Lizenz oder (nach Ihrer Wahl) jeder späteren
    veröffentlichten Version, weiterverbreiten und/oder modifizieren.

    OTE wird in der Hoffnung, dass es nützlich sein wird, aber
    OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
    Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
    Siehe die GNU Lesser General Public License für weitere Details.

    Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit diesem
    Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
*/

tinymce.addI18n('en', {
    language: "Language",
    note_desc: "Add note",
    note_edit_desc: "Edit note",
    correction_desc: "Add correction(s)",
    correction_edit_desc: "Edit correction(s)",
    break_desc: "Add break",
    break_edit_desc: "Edit break",
    gap_desc: "Add gap",
    gap_edit_desc: "Edit gap",
    number_desc: "Add number",
    number_edit_desc: "Edit number",
    note_title: "Please insert a note",
    note_type: "Note type",
    editorial: "Editorial note",
    local: "Local Note",
    canon: "Canon reference",
    changeOfHand: "Change of hand",
    other: "Other",
    note: "Note",
    note_data: "Information about the note",
    newHand: "Name of new hand (if identified)",
    break_title: "Please specify the break",
    break_data: "Information about the break",
    break_type: "Type of break",
    linebreak: "Line break",
    columnbreak: "Column break",
    pagebreak: "Page break",
    quire: "Quire",
    number: "Number",
    none: "None given",
    alignment: "Alignment",
    alignment_lj: "Left-justified",
    alignment_cj: "Centre-justified",
    alignment_rj: "Right-justified",
    alignment_indent: "Indented",
    alignment_hanging: "Hanging line",
    facs: "URL to digital image",
    page_recto: "recto",
    page_verso: "verso",
    papyrus_fibre_h: "\u2002\u2192",
    papyrus_fibre_v: "\u2002\u2191",
    pb_type: "Type of page break",
    pb_position: "Position",
    pb_hyphen: "Previous page ends with hyphenated word",
    pb_ghostpage: "No number (e.g. due to ghost page)",
    fibre_type: "Papyrus fibre",
    pb_page: "Page",
    pb_folio: "Folio",
    formework: "Forme work",
    covered: "Number of lines covered",
    range_covered: "Range of lines covered",
    text: "Text or number (as written on page)",
    number_attribute: 'Number (as used for XML attribute "n")',
    number_calculate: "Calculate number automatically",
    numeral: "Corresponding number",
    fw_commentary_text: "Commentary",
    fw_ews: "Ews",
    fw_pagenumber: "Page number (as written)",
    fw_quiresignature: "Quire signature",
    fw_running_title: "Running title",
    fw_chapter_title: "Chapter title",
    fw_chapter_number: "Chapter number",
    fw_lectionary_title: "Lectionary notation",
    fw_other_lections: "Lectionary text placeholder",
    fw_lectionary_incipit: "Lectionary incipit",
    fw_lectionary_explicit: "Lectionary explicit",
    fw_colophon: "Colophon",
    fw_ammonian: "Ammonian Section number",
    fw_eusebian: "Eusebian canon",
    fw_euthaliana: "Euthaliana",
    fw_gloss: "Gloss",
    fw_stichoi: "Stichoi",
    fw_isolated: "Isolated marginal note",
    fw_andrew: "Andrew of Caesarea",
    fw_ornament: "Ornament",
    fw_catchword: "Catchword",
    text_untranscribed: "Untranscribed commentary text",
    other_lections_untranscribed: "Untranscribed other lection(s)",
    firsthand_reading: "First hand reading",
    ut_videtur: "ut videtur",
    reading_title: "Please insert a reading",
    reading_data: "Information about the reading",
    reading_type: "Type of reading",
    correction: "Correction",
    commentary: "Commentary reading",
    alternative: "Alternative reading",
    gloss: "Gloss",
    corrector_name: "Corrector name (hand)",
    firsthand: "First hand",
    secunda_manu: "Secunda manu",
    glossator: "Glossator",
    blank_firsthand: "Blank first hand",
    blank_correction: "Total deletion",
    corrector: "Corrector",
    corrector1: "Corrector 1",
    corrector2: "Corrector 2",
    corrector_text: "Corrector text",
    corrector_place: "Place of correction",
    firsthand_partial: "Extent of first hand",
    correction_partial: "Extent of correction",
    corr_partial_beginning: "Partial (beginning)",
    corr_partial_end: "Partial (end)",
    corr_partial_complete: "Complete",
    unidentified_corrector: "(Unidentified) corrector",
    editorial_note: "Editorial Note",
    corr_not_applicable: "Not applicable",
    deletion: "Method of deletion",
    del_erased: "Erased",
    del_underline: "Underline",
    del_underdot: "Underdot",
    del_striketrough: "Strikethrough",
    del_vertical_line: "Vertical line",
    del_overdots: "Overdots",
    del_ringedcircled: "Ringed/Circled",
    gap_title: "Please specify the gap",
    gap_data: "Information about the gap",
    gap_type: "Writing material is",
    lacuna: "Lacuna (paper is absent)",
    illegible_text: "Illegible (paper is present)",
    unspecified: "Unspecified",
    part: "Part",
    inferredPage: "Inferred page",
    witnessEnd: "Witness End",
    info_lacuna_illegible: 'Please note, that this category was introduced only for existing transcriptions.\nYou should always try to assign "Lacuna" or "Illegible".',
    space: "Blank spaces",
    othertype: "User-defined type",
    reason: "Reason",
    unit: "Unit",
    unit_line: "Page-line",
    unit_char: "Char",
    unit_page: "Page",
    unit_quire: "Quire",
    unit_book: "Book",
    unit_chapter: "Chapter",
    unit_verse: "Verse",
    unit_stanza: "Stanza",
    unit_structural_line: "Line (verse or stanza)",
    unit_word: "Word",
    extent: "Extent",
    hand: "Hand",
    suppliedsource: "Supplied source",
    number_title: "Please specify the number",
    number_type: "Type of number",
    number_data: "Information about the number",
    gap: "Gap",
    supplied: "Supplied text",
    mark_as_supplied: "Mark as supplied",
    unclear: "Unclear (doubtful) reading",
    unclear_text_title: "Please specify the unclear text",
    tt_corr_deletion: "Hold down SHIFT to select ranges of options; CTRL (apple key) for multiple options",
    tt_corrtext: "Text of the correction",
    tt_extent: "This is the (non-negative) integer of missing lines excluding the remainder of the current line.\n'0' represents the remainder of the line only.\nOther allowed values are \"rest\" and \"all\".",
    charmap_greek_only: "Greek only",
    charmap_latin_only: "Latin only",
    charmap_slavistic_only: "Old Church Slavonic only",
    charmap_gujarati_only: "Gujarati only",
    charmap_avestan_only: "Avestan only",
    charmap_pahlavi_only: "Pahlavi only",
    charmap_all: "All glyphs",
    charmap_interpunction_signs_only: "Interpunction only",
    charmap_default_only: "Default only",
    unclear_text_info: "Please specify the uncertain letters",
    unclear_text_data: "Information about the uncertain letters",
    poor_image: "Poor image",
    faded_ink: "Faded ink",
    damage_to_page: "Damage to page",
    obscured_in_image: "Obscured in image",
    covered_by_tape: "Covered by tape",
    paperRepaired: "Paper repaired",
    abbreviatedText: "Abbreviated text",
    notExpected: "Not expected",
    supplied_source_title: "Please specify the supplied source",
    supplied_source_data: "Information about the supplied source",
    supplied_source: "Supplied source",
    restorer: "Restorer",
    transcriber: "Transcriber",
    paratext: "Marginalia",
    paratext_title: "Specify marginalia",
    paratext_data: "Information about the marginalia",
    position: "Position",
    position_pagetop: "Page top margin",
    position_pagebottom: "Page bottom margin",
    position_pageleft: "Page left margin",
    position_pageright: "Page right margin",
    position_coltop: "Column top margin",
    position_colbottom: "Column bottom margin",
    position_colleft: "Column left margin",
    position_colright: "Column right margin",
    position_lineleft: "Line left margin",
    position_lineright: "Line right margin",
    position_above: "Above line",
    position_below: "Below line",
    position_thispoint: "Here",
    position_overwritten: "Overwritten text",
    position_ontheline: "On the line",
    alignment_l: "Left",
    alignment_r: "Right",
    alignment_c: "Center",
    abbr_title: "Please specify abbreviation",
    abbr_data: "Information about the abbreviation",
    abbr_type: "Type of abbreviation",
    abbr_nomenSacrum: "Nomen sacrum",
    abbr_numeral: "Numeral",
    abbr_suspension: "Suspension",
    abbr_expansion: "Expansion",
    abbr_expansion_prev: "Previous expansions",
    spaces_title: "Please specify the blank spaces",
    spaces_data: "Information about the blank spaces",
    reading_list: "List of corrections",
    metadata_title: "Options for meta data",
    meta_tab_title: "Title statement",
    meta_tab_publication: "Publication statement",
    meta_tab_source: "Source description",
    meta_tab_encoding: "Encoding",
    meta_title_data: "Title statement",
    meta_title: "Document title (long)",
    meta_title_document: "Document title (short)",
    meta_title_collection: "Title of collection",
    meta_title_work: "Title of work",
    meta_title_short: "Short title",
    meta_title_respStmt: "Other data",
    meta_resp: "Created by",
    meta_funder: "Funder",
    meta_sponsor: "Sponsor",
    meta_editorialStmt: "Editorial statement",
    meta_edition_version: "Version",
    meta_edition_date: "Date",
    meta_publicationStmt: "Publication statement",
    meta_publisher: "Publisher",
    meta_publication_date: "Publication date",
    meta_publication_availability: "Availibility",
    meta_sourceDesc: "Source Description",
    meta_msDesc_country: "Country",
    meta_msDesc_settlement: "Settlement",
    meta_msDesc_repository: "Repository",
    meta_msDesc_idno: "ID",
    meta_msDesc_msName: "Manuscript name",
    meta_msDesc_altIdentifier: "Alternative Identifier",
    type: "Typ",
    meta_editorialDecl: "Editorial practise declaration",
    meta_encoding_panel: "Encoding information",
    meta_projectDesc: "Project description",
    meta_encodingDesc: "Encoding description",
    meta_revisionDesc: "Revision description",
    meta_tab_general: "Misc",
    meta_general: "Misc settings",
    empty_other: "Please enter text for all required and all &quot;other&quot; fields",
    empty_extent: "Please check the values for unit and extent",
    invalid_extent: "Extent can only be a non-negative integer or &quot;all&quot; or &quot;rest&quot;",
    empty_number: "Please enter a number (used as attribute &quot;n&quot;)",
    empty_text: "Please enter a text",
    empty_margin: "Please select a marginal position",
    empty_all: "Please enter information for all fields",
    empty_covered: "Please enter the number of covered lines",
    invalid_char: "Please enter a valid Unicode expression",
    value_too_small: "The value for the number of lines has to be at least 0",
    save: 'Your changes have not been saved yet.\nClick "OK" to save them or "Cancel" to discard changes.',
    capitals_title: 'Please specify the capitals',
    capitals_data: 'Information about capitals',
    capitals_height: 'Height of the capitals',
    capitals_unit: 'line(s)',
    verses_title: 'Modify structure',
    verse_insert: 'Insert verse number: ',
    verse_remove: 'Remove the following verse(s) completely: ',
    chapter_insert: 'Insert chapter number: ',
    chapter_remove: 'Remove the following chapter number(s):',
    book_insert: 'Insert book identifier: ',
    book_remove: 'Remove the following book number(s):',
    stanza_insert: 'Insert stanza number: ',
    stanza_remove: 'Remove the following stanza(s) completely: ',
    line_insert: 'Insert line number: ',
    line_remove: 'Remove the following line(s) completely: ',
    verseline_insert: 'Insert verseline number: ',
    verseline_remove: 'Remove the following verse line(s) completely: ',
    ritualdirection_insert: 'Insert ritual direction number: ',
    ritualdirection_remove: 'Remove the following ritual direction(s) completely: ',
    translation_insert: 'Insert translation',
    commentary_insert: 'Insert commentary',
    standalone_insert: 'Standalone',
    book: 'Book',
    chapter: 'Chapter',
    verse: 'Verse',
    verseline: 'Verseline',
    stanza: 'Stanza',
    line: 'Line',
    ritualdirection: 'Ritual direction',
    menu_add: 'Add',
    menu_edit: 'Edit',
    menu_delete: 'Delete',
    menu_break: 'Break',
    menu_corrections: 'Correction',
    menu_deficiency: 'Deficiency',
    menu_uncertain: 'Uncertain letters',
    menu_gap: 'Gap',
    menu_witnessend: 'Witness End',
    menu_ornamentation: 'Ornamentation',
    menu_highlight_text: 'Highlight text',
    menu_hl_rubrication: 'Rubrication',
    menu_hl_gold: 'Gold',
    menu_hl_color: 'Colour',
    menu_hl_other_color: 'Other colour',
    menu_hl_black: 'Black',
    menu_hl_red: 'Red',
    menu_hl_blue: 'Blue',
    menu_hl_green: 'Green',
    menu_hl_yellow: 'Yellow',
    menu_hl_other: 'Other',
    menu_hl_overline: 'Overline',
    menu_hl_capitals: 'Capitals',
    menu_displaced_text: 'Displaced text',
    menu_dt_above: 'Above',
    menu_dt_below: 'Below',
    menu_dt_margin: 'In the margin',
    menu_dt_other: 'Other',
    menu_subscript: 'Subscript',
    menu_superscript: 'Superscript',
    menu_upsidedown: 'Upside down',
    menu_special_chars: 'Insert special characters',
    menu_abbreviations: 'Abbreviation',
    menu_marginalia: 'Marginalia',
    menu_note: 'Note',
    menu_punctuation: 'Punctuation',
    menu_punctuation_add: 'Add punctuation',
    menu_punctuation_add_char: 'Add punctuation character',
    menu_punctuation_add_char_general: 'General',
    menu_punctuation_add_char_avestan: 'Avestan',
    menu_punctuation_add_char_pahlavi: 'Pahlavi',
    menu_punctuation_add_dots: 'Dots',
    menu_punctuation_add_circles: 'Circles',
    menu_punctuation_add_lines: 'Lines',
    menu_punctuation_add_other: 'Other',
    punctuation_other_title: 'Add an unicode punctuation character',
    punctuation_other_title_special: 'Add a special punctuation',
    menu_blank_spaces: 'Blank spaces',
    menu_verses: 'Modify verses',
    menu_structure: 'Structure',
    menu_language: 'Language',
    //menu_docInfo : 'Document information',
    menu_language_position: 'Change language at this point',
    menu_language_range: 'Change language for the selected text',
    menu_graphic: 'Graphical element',
    infotext_numeral: 'Numeral',
    infotext_suspension: 'Suspension',
    infotext_editorial_expansion: 'Editorial expansion',
    infotext_rendition: 'Rendition',
    infotext_number: 'Number',
    infotext_alignment: 'Alignment',
    infotext_page_number_sequence: 'Page number (in sequence)',
    infotext_no_number: 'No number given',
    infotext_url: 'URL to digital image',
    infotext_editorial_note: 'Editorial Note',
    infotext_local_note: 'Local Note',
    infotext_canon_reference: 'Canon reference',
    infotext_change_of_hand: 'Change of Hand',
    infotext_new_hand: 'New hand',
    infotext_deleted: 'Deleted',
    infotext_method_of_deletion: 'Method(s) of deletion',
    infotext_paratext_type: 'Marginalia type',
    infotext_untranscribed: 'This is untranscribed text',
    infotext_untranscribed_text: 'This is untranscribed commentary text',
    infotext_untranscribed_other_lections: 'This is untranscribed lectionary text',
    infotext_lines_covered: 'line(s) covered',
    infotext_within_line: 'within the line',
    infotext_value: 'Value',
    infotext_position: 'Position',
    infotext_no_info_reason: 'No information about the reason and extension of the gap available',
    infotext_lacuna: 'Lacuna',
    infotext_illegible: 'Illegible text',
    infotext_absent_text: 'Absent text',
    infotext_dt_above: 'Displaced above',
    infotext_dt_below: 'Displaced below',
    infotext_dt_margin: 'Displaced in the margin',
    infotext_dt_other: 'Displaced',
    infotext_highlighted_text: 'Highlighted text',
    infotext_punctuation_mark: 'Punctuation mark',
    infotext_punctuation_mark_special: 'Special punctuation mark',
    infotext_omission: 'Omission',
    infotext_language: 'Language',
    error_part_abbr: 'Error at part-worded abbreviation. Parentheses do not match or invalid nesting!',
    partial_information: 'Partial',
    initial_portion: 'Partial (initial portion)',
    medial_portion: 'Partial (medial portion)',
    final_portion: 'Partial (final portion)',
    remove_partial: 'Remove partial information',
    previous_hyphenation: 'Previous page ends with an hyphenated word',
    no_previous_hyphenation: 'Previous page ends with a complete word',
    warning_deletion_inner_Node: 'This node has a parent node and can not be removed.\nPlease remove the Format of the parent node first.',
    help: 'Help',
    apply: 'Apply',
    menu_info: 'This is version: ',
    changelog: 'Changelog',
    clipboard: 'To clipboard',
    clipboard_note: 'Please press Ctrl+C (Cmd+C) for savely copying the XML to the clipboard.',
    other_ornamentation: 'Type of ornamentation',
    title_other_ornamentation: 'Other type of ornamentation',
    insert: 'Insert',
    cancel: 'Cancel',
    new_hand: 'New',
    close: 'Close',
    reason_for_language_change: 'Reason for language change',
    language_name: 'Language',
    mainlanguage: 'Main document language',
    previouslanguage: 'Previous language',
    avestan: 'Avestan',
    avestan_avst: 'Avestan in Avestan Script',
    avestan_phlv: 'Avestan in Pahlavi Script',
    avestan_fa: 'Avestan in New Persian Script',
    avestan_gujr: 'Avestan in Gujarati Script',
    gujarati: 'Gujarati',
    gujarati_gujr: 'Gujarati in Gujarati Script',
    gujarati_arab: 'Gujarati in Arabic Script',
    gujarati_jaina: 'Gujarati in Jaina Nagari Script',
    gujarati_deva: 'Gujarati in Devanagari Script',
    gujarati_avst: 'Gujarati in Avestan Script',
    pahlavi_avst: 'Zoroastrian Middle Persian in Avestan Script',
    pahlavi_phlv: 'Zoroastrian Middle Persian in Pahlavi Script',
    pahlavi_phli: 'Middle Persian in inscriptional Pahlavi Script',
    pahlavi_gujr: 'Zoroastrian Middle Persian in Gujarati Script',
    pahlavi_fa: 'Zoroastrian Middle Persian in New Persian Script',
    persian: 'Persian',
    persian_phlv: 'New Persian in Pahlavi Script',
    persian_avst: 'New Persian in Avestan Script',
    sanskrit: 'Sanskrit',
    sanskrit_jaina: 'Sanskrit in Jaina Nagari Script',
    sanskrit_deva: 'Sanskrit in Devanagari Script',
    arabic: 'Arabic',
    sameasbefore: 'Same as before the change',
    ritual: 'Ritual direction',
    translation: 'Translation',
    backtopreviouslanguage: 'Back to previous language',
    section: 'Section heading; dedication',
    untrans: 'Untranscribed text',
    changeofscript: 'Change of script',
    removeLanguage: 'Remove language information',
    language_title: 'Please specify the language',
    following_lang: 'Following language',
    langchange: 'Language changes to',
    palPhlv: 'Zoroastrian Middle Persian in Pahlavi Script',
    palAvst: 'Zoroastrian Middle Persian in Avestan Script',
    palPhli: 'Middle Persian in inscriptional Pahlavi Script',
    palGujr: 'Zoroastrian Middle Persian in Gujarati Script',
    palfa: 'Zoroastrian Middle Persian in New Persian script',
    ae: 'Avestan',
    aeAvst: 'Avestan in Avestan Script',
    aePhlv: 'Avestan in Pahlavi Script',
    aefa: 'Avestan in New Persian Script',
    aeGujr: 'Avestan in Gujarati Script',
    gu: 'Gujarati',
    guArab: 'Gujarati in Arabic Script',
    guGujr: 'Gujarati in Gujarati Script',
    guJaina: 'Gujarati in Jaina Nagari Script',
    guDeva: 'Gujarati in Devanagari Script',
    guAvst: 'Gujarati in Avestan Script',
    fa: 'Persian',
    faAvst: 'New Persian in Avestan Script',
    faPhlv: 'New Persian in Pahlavi Script',
    sa: 'Sanskrit',
    saJaina: 'Sanskrit in Jaina Nagari Script',
    saDeva: 'Sanskrit in Devanagari Script',
    ar: 'Arabic',
    doclang: 'Document language',
    add_structure: 'Add structure',
    delete_structure: 'Remove structure',
    edit_structure: 'Edit structure',
    graphic: 'Brief description',
    title_graphic: 'Please specify the graphical element',
    graphic_data: 'Information about the graphical element',
    graphical_element: 'Graphical element',
    description: 'Description',
    editNumber_data: 'Information about the structure',
    editNumber: 'New number'
});
